import MuseScore 3.0
import QtQuick 2.9
MuseScore {
  menuPath: "Plugins.Dynamics Each Symbol Softer"
  version: "220918"
  onRun:{
  var bForceInstrDyn=true
  var es=curScore.selection.elements
  function tick(e){return e.parent.parent.tick || e.parent.tick} //NOTE || CHORD,REST
  function indexOf(ps,p){for(var i in ps){if(p.is(ps[i])) return i}}
  function getElement(track,tick){
    var c=curScore.newCursor()
    c.track=track
    c.rewindToTick(tick)
    var e=c.segment.elementAt(track)
    return e
  }
  var dyns=[]
  var dynspush=function(t){return function(d){  
    if(dyns[t].filter(function(dd){return dd.is(d)}).length==0) dyns[t].push(d) 
    // if(!~dyns[t].indexOf(d)) dyns[t].push(d) 
  }}
  for(var i in es){
    var e=es[i].type==Element.DYNAMIC? getElement(es[i].track, es[i].parent.tick) : es[i]
    if(~[Element.NOTE,  Element.CHORD,Element.REST].indexOf(e.type)){
      if(dyns[e.track]==undefined)dyns[e.track]=[]
      getDyn(e, function(d){dynspush(e.track)(d)})
      var t=(e.parent.staff||e.staff).part.startTrack
      if(bForceInstrDyn==true&&e.track!=t) getDyn(getElement(t, e.parent.parent.tick || e.parent.tick), function(d){
        if(dyns[t]==undefined)dyns[t]=[]
        dynspush(t)(d)
      })
    }
  }
  var dynMS=[
     {v:1  ,l:0   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:5  ,l:3   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:10  ,l:7   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:16  ,l:13   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:32  ,l:24  ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:48  ,l:40  ,t:'<sym>dynamicPiano</sym>'}
    ,{v:64  ,l:56  ,t:'<sym>dynamicMezzo</sym><sym>dynamicPiano</sym>'}
    ,{v:80  ,l:72  ,t:'<sym>dynamicMezzo</sym><sym>dynamicForte</sym>'}
    ,{v:96  ,l:88  ,t:'<sym>dynamicForte</sym>'}
    ,{v:112 ,l:104 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym>'}
    ,{v:126 ,l:119 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
    ,{v:127 ,l:127 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
  ]
  function dynVel(v){return dynMS.reduce(function (a,b){return b.l<=v?b:a })}
  function dynVelIndex(v){return dynMS.indexOf(dynVel(v))}
  function validIndex(i){
    return   i<0                   ? 0
           :       dynMS.length<=i ? dynMS.length-1
           :                         i
  }
  function getDyn(e,cb){
    var a=e.parent.parent.annotations || e.parent.annotations  //segment //NOTE || CHORD,REST
    if(a!=undefined)
      for (var n in a)
        if(a[n].type==Element.DYNAMIC && a[n].track==e.track) cb( a[n] )
  }
  function draw(d){
    dyns.map(function (des,t){if(des!=undefined){
      des.map(function(de){if(de!=undefined){
        var n=dynMS[validIndex(dynVelIndex(de.velocity)+d)]
        var e=newElement(Element.DYNAMIC)
        e.velocity= n.v
        e.text= n.t
        e.dynamicRange= de.dynamicRange
        e.visible= de.visible
        var c=curScore.newCursor()
        c.track=t
        c.rewindToTick(tick(de))
        c.add(e)
        removeElement(de)
      }})
    }})
  }
  draw(-1)
  }
} 