import MuseScore 3.0
import QtQuick 2.9
MuseScore {
  menuPath: "Plugins.Dynamics Louder"
  version: "220918"
  onRun:{
  var bForceInstrDyn=true
  var bNormTextChgVel=true
  var bClearAllDyn=true
  var perInstr=[]
  // {
  //   startTrack: curScore.parts[p].startTrack
  //   ,staffs:[
  //     track
  //      {
  //       e:
  //      ,selected:
  //      ,curDyn:[]
  //      ,first:staffref
  //      ,secplus:[staffref]
  //      }
  //   ]
  // }
  //
  //selection
  var es=curScore.selection.elements
  function tick(e){return e.parent.parent.tick || e.parent.tick} //NOTE || CHORD,REST
  function indexOf(ps,p){for(var i in ps){if(p.is(ps[i])) return i}}
  function enumOf(es,n){for(var e in es){if(n==es[e]) return e}}
  function getElement(track,tick){
    var c=curScore.newCursor()
    c.track=track
    c.rewindToTick(tick) 
    var e=c.segment.elementAt(track)
    // for(var x in e)console.log(x+' : '+e[x])
    // console.log('link '+enumOf(Element, e.type))
    return e
  }
  var dynToClear=[]
  for(var i in es){
    // console.log('s '+enumOf(Element, es[i].type))
    var e=es[i].type==Element.DYNAMIC? getElement(es[i].track,es[i].parent.tick) : es[i]
    // console.log('s '+enumOf(Element, e.type))
    if(~[Element.NOTE,  Element.CHORD,Element.REST].indexOf(e.type)){
      var p=indexOf(curScore.parts, e.staff.part)
      var t=e.track
      if(perInstr[p]==undefined) perInstr[p]={ staffs:[] }   //def array
      var o=perInstr[p].staffs[t]
      if(o==undefined || tick(e)<tick(o.e) ) perInstr[p].staffs[t] = {e:e, curDyn:[], selected:true}
      //
      dynToClear.push(e)
    }
  }
  //links
  function startTrack(p){return curScore.parts[p].startTrack}
  function getDyn(e,cb){
    var a=e.parent.parent.annotations || e.parent.annotations  //segment //NOTE || CHORD,REST
    if(a!=undefined)
      for (var n in a){
        // console.log('gd '+enumOf(Element, a[n].type))
        if(a[n].type==Element.DYNAMIC && a[n].track==e.track) cb( a[n] )
      }
  }
  perInstr.map(function (i,p){if(i!=undefined){
    i.staffs.map(function (k,t){if(k!=undefined){
      if(bForceInstrDyn==true && i.staffs[startTrack(p)]==undefined){
        var e=getElement(startTrack(p), tick(k.e))
        i.staffs[startTrack(p)]={e: e, curDyn:[], selected:false}
        getDyn(e, function (d){i.staffs[e.track].curDyn.push(d)})
      }
      if(k.e.track!=startTrack(p)){
        if(i.staffs[startTrack(p)]!=undefined){
          k.first=i.staffs[startTrack(p)]
          if(i.staffs[startTrack(p)].secplus==undefined) i.staffs[startTrack(p)].secplus=[] //def array
          i.staffs[startTrack(p)].secplus.push(k)
        }
      }
      getDyn(k.e, function (d){i.staffs[k.e.track].curDyn.push(d)})
    }})
  }})
  var dynMS=[
     {v:1  ,l:0   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:5  ,l:3   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:10  ,l:7   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:16  ,l:13   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:32  ,l:24  ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
    ,{v:48  ,l:40  ,t:'<sym>dynamicPiano</sym>'}
    ,{v:64  ,l:56  ,t:'<sym>dynamicMezzo</sym><sym>dynamicPiano</sym>'}
    ,{v:80  ,l:72  ,t:'<sym>dynamicMezzo</sym><sym>dynamicForte</sym>'}
    ,{v:96  ,l:88  ,t:'<sym>dynamicForte</sym>'}
    ,{v:112 ,l:104 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym>'}
    ,{v:126 ,l:119 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
    ,{v:127 ,l:127 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
  ]
  var defaultDyn=7 
  function dynVel(v){return dynMS.reduce(function (a,b){return b.l<=v?b:a })}
  function dynVelIndex(v){return dynMS.indexOf(dynVel(v))}
  function validIndex(i){
    return   i<0                   ? 0
           :       dynMS.length<=i ? dynMS.length-1
           :                         i
  }
  //
  var bSelDynOverCurInstrDyn=false
  function staffs(p,t){return (t-curScore.parts[p].startTrack+1)/4}
  var drawTrack=[]
  perInstr.map(function (i,p){if(i!=undefined){
    i.staffs.map(function (k,t){if(k!=undefined && k.selected==true){
      var o=bForceInstrDyn==true&&k.e.track!=startTrack(p)?k.first:k
      var oCurDyn=o.curDyn[0]!=undefined
      var kCurDyn=k.curDyn[0]!=undefined
      var useCurDyn= !oCurDyn&&!kCurDyn               ? undefined
                   : !oCurDyn||bSelDynOverCurInstrDyn ? k
                   :                                    o
      drawTrack[o.e.track]={
          e: o.e
        , curDyn: useCurDyn? {velocity: useCurDyn.curDyn[0].velocity, text: useCurDyn.curDyn[0].text} :undefined
        , velIndex: useCurDyn? dynVelIndex(useCurDyn.curDyn[0].velocity) : defaultDyn
        , range: bForceInstrDyn? 1 : 0  // element.dynamicRange = 1=part ;  =0=staff
      }
      k.curDyn.map(function (c){removeElement(c)})
      o.curDyn.map(function (c){removeElement(c)})
    }})
  }})
  //
  var bNormVel=false
  var bNormTextAll=false
  function draw(dd){
    drawTrack.map(function (k,t){if(k!=undefined){
      var d= k.curDyn==undefined? 0 : (dd||0)
      var m=dynMS[validIndex(k.velIndex+d)]
      var e=newElement(Element.DYNAMIC)
      e.velocity=   d!=0 || bNormVel==true || k.curDyn==undefined ? m.v :  k.curDyn.velocity
      e.dynamicRange= k.range
      e.text= ( d!=0 && bNormTextChgVel==true ) || bNormTextAll==true || k.curDyn==undefined? m.t : k.curDyn.text
      var c=curScore.newCursor()
      c.track=k.e.track
      c.rewindToTick(tick(k.e))
      c.add(e)
    }})
  }
  //console.log(dynToClear)
  if(bClearAllDyn) dynToClear.map(function(e){
    getDyn(e, function(d){removeElement(d)})
    if(bForceInstrDyn) getDyn(getElement((e.parent.staff||e.staff).part.startTrack, e.parent.parent.tick || e.parent.tick), function(d){removeElement(d)})
  })
  draw(1)
  }
} 